#ifndef _UNIT_TEST_AF_MT_HARMONIC_POTENTIAL_H_
#define _UNIT_TEST_AF_MT_HARMONIC_POTENTIAL_H_

#include "test_module_base.h"

class UnitTestAFMTHarmonicPotential : public TestModuleBase {
  public:
    UnitTestAFMTHarmonicPotential() {}
    virtual ~UnitTestAFMTHarmonicPotential() {}

    virtual void RunTests();
    virtual void SetTests();

    // Specialized init functionality
    void InitSystem(system_parameters *parameters,
                    system_properties *properties);

    // Tests
    bool TestPotentialandUpdate();
    bool TestRandomSetup();
    bool TestForceTorqueBalance(system_parameters *parameters,
                                system_properties *properties,
                                bool print_info);

    // bookeeping and stuffs
    double **f_comp_;
    double **t_comp_;
    double **virial_comp_;
    int *calc_matrix_;
};

#endif
